<template>
  <div>
    <h2 id="page-heading" data-cy="AgendaHeading">
      <span v-text="$t('gatewayApp.pacientesAgenda.home.title')" id="agenda-heading">Agenda</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesAgenda.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'AgendaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-agenda"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesAgenda.home.createLabel')"> Create a new Agenda </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && agenda && agenda.length === 0">
      <span v-text="$t('gatewayApp.pacientesAgenda.home.notFound')">No agenda found</span>
    </div>
    <div class="table-responsive" v-if="agenda && agenda.length > 0">
      <table class="table table-striped" aria-describedby="agenda">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('horaMedicamento')">
              <span v-text="$t('gatewayApp.pacientesAgenda.horaMedicamento')">Hora Medicamento</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'horaMedicamento'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('medicamento.nombre')">
              <span v-text="$t('gatewayApp.pacientesAgenda.medicamento')">Medicamento</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'medicamento.nombre'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="agenda in agenda" :key="agenda.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'AgendaView', params: { agendaId: agenda.id } }">{{ agenda.id }}</router-link>
            </td>
            <td>{{ agenda.horaMedicamento }}</td>
            <td>
              <div v-if="agenda.medicamento">
                <router-link :to="{ name: 'MedicamentoView', params: { medicamentoId: agenda.medicamento.id } }">{{
                  agenda.medicamento.nombre
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'AgendaView', params: { agendaId: agenda.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'AgendaEdit', params: { agendaId: agenda.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(agenda)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.pacientesAgenda.delete.question" data-cy="agendaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-agenda-heading" v-text="$t('gatewayApp.pacientesAgenda.delete.question', { id: removeId })">
          Are you sure you want to delete this Agenda?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-agenda"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeAgenda()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./agenda.component.ts"></script>
